<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_8</title>
</head>
<body>
    <h1>Capitulo 8</h1>
    <a>Ejercicio 9</a>

    <script>   

        const parentesisPosi = (n, abrir,  cerrar, p, ans) => { 

            if (abrir === n && cerrar === n) {
                ans.push(p);
                return;
            }            

            if (abrir < n) {
                parentesisPosi(n, abrir + 1, cerrar, p + "(", ans);
            }
            
            if (cerrar < abrir) {
                parentesisPosi(n, abrir, cerrar + 1, p + ")", ans);
            }
        }
 
        let n = 3,
          ans = [];
        parentesisPosi(n, 0, 0, "", ans);
        console.log(`Combinaciones válidas de ${n} pares de paréntesis:`)
        for (var i = 0; i < ans.length; i++) {
            console.log(` "${ans[i]}" `);
        }
        
        
</script>
    
</body>
</html>